SystemOrganization addCategory: #Proxies!

Class subclass: #ClassProxy3
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxy3 classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:18'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ClassProxy3 methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:18'!
become: aClass
	className := aClass name.
	aClass fileOut.
	super become: aClass! !

!ClassProxy3 methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:18'!
doesNotUnderstand: aMessage
	| reloadedClass |
	(FileStream fileNamed: className, '.st') fileIn.
	reloadedClass := Smalltalk at: className. 
	self becomeForward: reloadedClass.
	^aMessage sendTo: reloadedClass! !

Class subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:35'!
doesNotUnderstand: aMessage
	self becomeForward: self loadBackSerializedObjectsFromFile.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName
	^ fileName! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName: anObject
	fileName := anObject! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:49'!
loadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: self fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

ProtoObject subclass: #ClassProxy
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxy commentStamp: 'NouryBouraqadi 8/30/2010 11:15' prior: 0!
Evaluate the following. The last line causes the image to crash.

o := MyObject new.
o foo: 123.
p := ClassProxy new.
p become: MyObject.
o == nil.
o foo.
!

!ClassProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 13:36'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy new.
p become: MyClass.
MyClass flushCache.
ClassProxy flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ClassProxy methodsFor: 'accessing' stamp: 'NouryBouraqadi 8/30/2010 10:53'!
become: aClass
	className := aClass name.
	aClass fileOut.
	super become: aClass! !

!ClassProxy methodsFor: 'messagehandling' stamp: 'NouryBouraqadi 8/30/2010 11:13'!
doesNotUnderstand: aMessage
	| reloadedClass |
	(FileStream fileNamed: className, '.st') fileIn.
	reloadedClass := Smalltalk at: className. 
	self becomeForward: reloadedClass.
	^aMessage sendTo: reloadedClass! !

TestCase subclass: #ATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ATest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:54'!
serializeAndWriteToDisk: anObject	
	| file result |

	file := FileStream fileNamed: (self name, ' test').
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ self name, ' test'.! !

!ATest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:55'!
testASimpleOne
	"A points to B which is an array that points to C and D. "	
	| c d b a proxy fileName hello today |
	
	hello := 'Hello'.
	today := Date today.
	
	c := ClassWith1Var new var1: hello.
	d := ClassWith1Var new var1: today.
	b := Array with: c with: d.
	a := ClassWith1Var new var1: b.
	
	"We "
	d := c := nil.
	
	"We put a proxy and become for B."
	fileName := self serializeAndWriteToDisk: b. 
	proxy := ObjectProxy forFileName: fileName.
	b becomeForward: proxy. 
	self assert: a var1 = b.
	self assert: (a var1 first var1 = hello).
	self assert: (a var1 last var1 = today).
	! !

Behavior subclass: #ClassProxy2
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxy2 classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:04'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy2 new.
p become: MyClass.
MyClass flushCache.
ClassProxy2 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ClassProxy2 methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:03'!
become: aClass
	className := aClass name.
	aClass fileOut.
	super become: aClass! !

!ClassProxy2 methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 14:04'!
doesNotUnderstand: aMessage
	| reloadedClass |
	(FileStream fileNamed: className, '.st') fileIn.
	reloadedClass := Smalltalk at: className. 
	self becomeForward: reloadedClass.
	^aMessage sendTo: reloadedClass! !

Object subclass: #ClassWith1Var
	instanceVariableNames: 'var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1
	^ var1! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1: anObject
	var1 := anObject! !

Object subclass: #ClassWith2Var
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1
	^ var1! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1: anObject
	var1 := anObject! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var2
	^ var2! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var2: anObject
	var2 := anObject! !

Object variableSubclass: #MessageCatchingProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

MessageCatchingProxy class
	instanceVariableNames: 'unwrapSelector object'!

MessageCatchingProxy class
	instanceVariableNames: 'unwrapSelector object'!

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:56'!
handleMessage: aMessage forProxy: proxy

	self shouldBeImplemented ! !

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:55'!
setObject: anObject

	object := anObject! !

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:56'!
wrap: anObject

	| anonClass |
	
	anonClass := self clone.
	anonClass setObject: anObject; methodDict: nil ; superclass: self.
	
	^ anonClass basicNew! !

!MessageCatchingProxy methodsFor: 'as yet unclassified' stamp: 'sig 11/25/2008 00:03'!
cannotInterpret: aMessage
	^ aMessage lookupClass handleMessage: aMessage forProxy: self
! !

Object subclass: #MyClass
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!MyClass methodsFor: 'accessing' stamp: 'NouryBouraqadi 8/30/2010 10:59'!
foo
	^foo! !

!MyClass methodsFor: 'accessing' stamp: 'NouryBouraqadi 8/30/2010 10:59'!
foo: anObject
	foo := anObject! !
